
#include "StdAfx.h"
#include "Utily.h"
#include "Random.h"
#include "Big.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;

#endif

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyWordArray - 

MyWordArray::MyWordArray (MyWordArray& copy) : CWordArray() {
	AddCopy(copy);
}
	
void MyWordArray::MyAdd (int nom) {
	if (GetSize()<=0) InsertAt(0,nom);
	else MyAddRec(nom,0,GetUpperBound());
}
	
void MyWordArray::MyAddRec (int nom, int nL, int nR) {
	if (nR<nL) 
		InsertAt(nL,nom); 
	else if (nR==nL) { 
		int nOld = GetAt(nL);
		if (nom<nOld) InsertAt(nL,nom);
		else if (nom>nOld) InsertAt(nL+1,nom);
	}
	else if (nR==nL+1) { 
		int nOld = GetAt(nL);
		if (nom<nOld) InsertAt(nL,nom);
		else if (nom>nOld) MyAddRec(nom,nR,nR);
	}
	else {
		int nM = (nL + nR) / 2;
		int nOld = GetAt(nM);
		if (nom<nOld) MyAddRec(nom,nL,nM-1);
		else if (nom>nOld) MyAddRec(nom,nM+1,nR);
	}
}
	
bool MyWordArray::ExistsNom (int nom) {
	/*
	for (int i=0; i<GetSize(); i++)  if (GetAt(i)==nom)  return true;
	return false;
	*/
	return (GetSize()<=0) ? false : ExistsNomRec(nom,0,GetUpperBound());
}
	
bool MyWordArray::ExistsNomRec (int nom, int nL, int nR) {
	if (nR<nL) return false;
	if (nR==nL) return GetAt(nL)==nom;
	int nM = (nL + nR) / 2;
	int nOld = GetAt(nM);
	return (nom==nOld) ? true : (nom<nOld) ? ExistsNomRec(nom,nL,nM-1) : ExistsNomRec(nom,nM+1,nR);
}
	
/*
MyWordArray::operator= (MyWordArray& copy) {
	RemoveAll();
	AddCopy(copy);
}
*/
		
void MyWordArray::DeleteNom (int nom) {
	for (int i=0; i<GetSize(); i++)  if (GetAt(i)==nom)  RemoveAt(i);
}
	
ostream& operator<< (ostream& os, MyWordArray& wordarray) {
	// for (int i=0; i<wordarray.GetSize(); i++)  os << wordarray.GetAt(i) << " ";
	//       1-25 27-45 48-99 
	for (int i=0; i<wordarray.GetSize(); i++) {	// sic!    i   
		int j = wordarray.Monolit(i);
		if (j==i) cout << wordarray.GetAt(i);
		else if (j==i+1) cout << wordarray.GetAt(i) << " "  << wordarray.GetAt(j);
		else cout << wordarray.GetAt(i) << "-"  << wordarray.GetAt(j);
		cout << " ";
		i = j;	// sic!
	}
	return os;
}

void MyWordArray::AddCopy (MyWordArray& copy) {
	for (int i=0; i<copy.GetSize(); i++)  Add(copy.GetAt(i));
}
	
int MyWordArray::Monolit (int nStart) {
	//     ,  
	return (nStart<GetUpperBound() && GetAt(nStart+1)==GetAt(nStart)+1) ?
		Monolit(nStart+1) : nStart;
}

/*    
bool operator>= (MyWordArray& wa1, MyWordArray& wa2) {
	for (int i=0; i<wa2.GetSize(); i++) {
		int nnn = wa2.GetAt(i);
		if (!wa1.ExistsNom(nnn)) return false;
	}
	return true;
}

bool operator== (MyWordArray& wa1, MyWordArray& wa2) {
	return wa1>=wa2 && wa2>=wa1;
	// ,     - -
}
*/

bool operator== (MyWordArray& wa1, MyWordArray& wa2) {
	int nSize = wa1.GetSize();
	if (nSize!=wa2.GetSize()) return false;
	for (int i=0; i<nSize; i++)  if (wa1.GetAt(i)!=wa2.GetAt(i)) return false;
	return true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MySubTask (Big) - 

MySubTask::MySubTask (MyQube* pQube, MyArrayPlane* pArrayPlane) 
	// : QubeThis(pQube->GetDim()) 
{
	this->pQube = pQube;
	this->pArrayPlane = pArrayPlane;
	//  !     (MyTask)
	this->pQubeThis = new MyQube(pQube->GetDim());
	InitStart();
}

MySubTask::MySubTask (MySubTask& copy) : 
	//arrYes(copy.arrYes), arrNo(copy.arrNo), QubeThis(copy.QubeThis) 
	arrYes(copy.arrYes), arrNo(copy.arrNo)
{
	this->pQube = copy.pQube;
	this->pArrayPlane = copy.pArrayPlane;
	this->pQubeThis = new MyQube(*copy.pQubeThis);
	this->nHowTimes = copy.nHowTimes;
	this->nBound = copy.nBound;
}

void MySubTask::InitStart () {
	nHowTimes = 0;
	nBound = -1;
}
		
int MySubTask::SelectPlaneSimple () {
	int nBestAdd = 0;	//  -  1     
	int nBestNom = -1;	//  
	//for (int i=0; i<pArrayPlane->GetSize(); i++) {
	for (int i=pArrayPlane->GetUpperBound(); i>=0; i--) {
		if (arrYes.ExistsNom(i) || arrNo.ExistsNom(i)) continue;
		MyPlane* pPlane = (MyPlane*)pArrayPlane->GetAt(i);
		//int nTmp = QubeThis.HowManyNew(*pPlane);
		int nTmp = pQubeThis->HowManyNew(*pPlane);
		if (nTmp<=nBestAdd) continue;
		nBestAdd = nTmp;
		nBestNom = i;
	}
	return nBestNom;
}
		
int MySubTask::BoundSimple ()  { 
	//return *pQube - QubeThis; 
	//return *pQube - *pQubeThis; 
	//   -    
	return pQube->GetSumma() - pQubeThis->GetSumma();
}

void MySubTask::AddYes (int nom) {
	arrNo.DeleteNom(nom);	// sic! (in case)
	if (arrYes.ExistsNom(nom)) return;
	arrYes.MyAdd(nom);
	InitStart();
	//       (QubeThis)  1
	MyPlane* pPlaneAdd = (MyPlane*)(pArrayPlane->GetAt(nom));
	pPlaneAdd->InitSearch();
	for (;;) {
		int m = pPlaneAdd->MakeNext();
		if (m<0) break;
		//QubeThis.SetTrue(m);
		pQubeThis->SetTrue(m);
	}
}

void MySubTask::AddNo (int nom) {
	if (arrYes.ExistsNom(nom) || arrNo.ExistsNom(nom)) return;
	arrNo.MyAdd(nom);	// sic!
	InitStart();
}
	
int MySubTask::GetBound () { 
	if (nBound<0) {
		int n1 = BoundSimple();
		int n2 = arrYes.GetSize();
		int n3 = arrNo.GetSize();
		nBound = 15*nHowTimes + 10*n1 + 3*n2 + n3; 
	}
	return nBound; 
}

/*
MySubTask* MySubTask::MakeRight () {
	int nom = SelectPlaneSimple();
	if (nom<0) return NULL;
	return MakeRight(nom);
}
*/

MySubTask* MySubTask::MakeRight (int nom) {
	MySubTask*  stRight = new MySubTask(*this); //  
	stRight->AddYes(nom);
	this->AddNo(nom);
	return stRight;
}

int MySubTask::GetRandomSquare () {
	RndInt squares;
	for (int m=0; m<pQube->GetMDim(); m++) {
		//if (QubeThis.Get(m)) continue;
		if (pQubeThis->Get(m)) continue;
		if (pQube->Get(m)) squares.Add(m);
	}
	return squares.GetAnswer();
}
	
void MySubTask::IntHowTimes () { 
	nHowTimes++; 
	nBound = -1;
}

bool MySubTask::operator== (MySubTask& other) {
	//return arrYes==other.arrYes && arrNo==other.arrNo;
	return arrYes==other.arrYes;
}

ostream& operator<< (ostream& os, MySubTask& subtask) {
	int nSimple = subtask.BoundSimple();
	if (nSimple==1) os << "[" << subtask.GetRandomSquare() << "]"; else os << nSimple;
	os << "(" << subtask.GetBound() << ")";
	return os;
}

ostream& operator<= (ostream& os, MySubTask& subtask) {
	os << subtask << endl;
	os << "Yes:" << subtask.arrYes << endl;
	os << "No: " << subtask.arrNo << endl;
	return os;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyArraySubTask (Big) - 

MyArraySubTask::~MyArraySubTask () {
	for (int i=0; i<GetSize(); i++) {
		MySubTask* pSubTask = (MySubTask*)GetAt(i);
		delete pSubTask;
	}
}

void MyArraySubTask::MyAdd (MySubTask* pAdd) {
	int nAdd = pAdd->GetBound();
	int nSize = GetSize();
	for (int i=0; i<nSize; i++) {
		MySubTask* pTmp = (MySubTask*)GetAt(i);
		int nTmp = pTmp->GetBound();
		if (nAdd>nTmp) continue;
		if (nAdd<nTmp) {	//       
			InsertAt(i,pAdd,1);	// 3rd argument - in case
			if (GetSize()!=nSize+1) ::MyError(12);
			return;
		}
		//    ; ,      
		if (*pAdd==*pTmp) return;
	}
	Add(pAdd);
}

/*	
MySubTask* MyArraySubTask::ExtractFirst () {
	if (GetSize()<=0) return NULL;
	MySubTask* pSTReturn = (MySubTask*)GetAt(0);
	if (pSTReturn->Ready()) ::MyError(9);
	pSTReturn->IntHowTimes();
	this->RemoveAt(0);
	return pSTReturn;
}
*/
	
MySubTask* MyArraySubTask::Extract (int nom) {
	if (GetSize()<=0) return NULL;
	MySubTask* pSTReturn = (MySubTask*)GetAt(nom);
	if (pSTReturn->Ready()) ::MyError(9);
	pSTReturn->IntHowTimes();
	this->RemoveAt(nom);
	return pSTReturn;
}

void MyArraySubTask::Clean (int nOpt) {
	//   ,      
	if (nOpt<999999) {
		for (int i=GetUpperBound(); i>=0; i--) {	
			//  ,      
			MySubTask* pST = (MySubTask*)GetAt(i);
			if (pST->BoundYes()+1 < nOpt) continue;
			delete pST;
			RemoveAt(i);
		}
	}
	//    -   
	for (int i=0; i<10; i++) {
		if (i>GetUpperBound()-1) return;
		MySubTask* pSTMain = (MySubTask*)GetAt(i);
		for (int j=min(100,GetUpperBound()); j>i; j--) {
			//  -  
			MySubTask* pSTSlave = (MySubTask*)GetAt(j);
			if (!(*pSTMain==*pSTSlave)) continue;
			delete pSTSlave;
			RemoveAt(j);
		}
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyTask (Big) - 
	
MyTask::MyTask (MyQube& qube) : MyArraySubTask(), QubeMain(qube), ltMain(&qube,&arrPlaneMain) {
	nOpt = 999999;
	for (int i=0; i<200; i++) {	//   -     
		int n = ltMain.Step();
		//if (n==0) break;
	}
	//       
	MySubTask* pSTFirst = new MySubTask(&qube,&arrPlaneMain);
	this->Add(pSTFirst);
}
	
void MyTask::ExtractMake (int nom, double rProbaMakePlane) {
	MySubTask* stCurrent = Extract(nom);
	if (stCurrent==NULL) ::MyError(14);	//    
	int nomPlane = -1;
	if (!::RndLT(rProbaMakePlane))	//    -   !
		nomPlane = stCurrent->SelectPlaneSimple();
	if (nomPlane<0) {	//   (  ) -  
						//       -   ;
						// ,    ,   ;
						//        
						// (     ) -
						//     2,  3  
						//     MakeRight()) -
						// , ,     ;
						//        
		int m = stCurrent->GetRandomSquare();
		if (m<0) ::MyError(9);
		//       :
		// int nom = arrPlaneMain.PlaneByPoint(m);
		//    :
		// MyPlane* planeNew = QubeMain.MakePlaneRnd(m);
		//      , 
		//  ()    
		//MyPlane* planeNew = QubeMain.MakePlaneGreedy(m);
		MyPlane* planeNew = QubeMain.MakePlaneRnd(m);
		//      
		if (planeNew==NULL) ::MyError(16);
		nomPlane = arrPlaneMain.ExistsPlane(planeNew);
		if (nomPlane==-1) ::MyError(15);
		if (nomPlane==-2) {	//    
			arrPlaneMain.Add(planeNew);
			nomPlane = arrPlaneMain.ExistsPlane(planeNew);	// once more
			if (nomPlane!=arrPlaneMain.GetUpperBound()) ::MyError(11);
		}
		//      ( -  )   nomPlane
	}
	// if (stCurrent->Tabu(nomPlane))  { MyAdd(stCurrent); return; }
	//    -   
	MySubTask* stR = stCurrent->MakeRight(nomPlane);
						//     NULL   
	MyAdd(stCurrent);	//      ;
						//  .      
	if (stR->Ready()) {	//  
		int n = stR->BoundYes();
		if (n<nOpt) nOpt = n; //    ,  -  arrYesOpt = stR->GetYes(); 
		delete stR;
	}
	else MyAdd(stR);
}
	
void MyTask::BigStep () {
	int i;
	ltMain.Step();
	if (::RndLT(0.1)) Clean(nOpt);
	////////// 1   
	if (GetSize()<=0) return;
	ExtractMake(0,0.2);
	//   -      - 
	//    ,   1 
  	//////////      1 - .. BoundSimple()
	if (GetSize()<=1) return;	// sic!
	int nom = -1, nMin = 999999;
	for (int i=1; i<GetSize(); i++) {	// sic!
		MySubTask* stCurrent = (MySubTask*)GetAt(i);
		int nKol = stCurrent->BoundSimple();
		if (nKol>=nMin) continue;
		nMin = nKol;
		nom = i;
	}
	if (nom<0) ::MyError(17);
	ExtractMake(nom,0.75);	
		//    -     ;
		// ..  -  
  	//////////     Yes
	if (GetSize()<=1) return;	// in case
	nom = -1, nMin = 999999;
	for (i=1; i<min(100,GetSize()); i++) {	// sic!
		MySubTask* stCurrent = (MySubTask*)GetAt(i);
		int nKol = stCurrent->BoundYes();
		if (nKol>=nMin) continue;
		nMin = nKol;
		nom = i;
	}
	if (nom<0) ::MyError(17);
	ExtractMake(nom,0.05);
	//////////     Yes+No
	if (GetSize()<=1) return;	// in case
	nom = -1, nMin = 999999;
	for (i=1; i<min(100,GetSize()); i++) {	// sic!
		MySubTask* stCurrent = (MySubTask*)GetAt(i);
		int nKol = stCurrent->BoundYesNo();
		if (nKol>=nMin) continue;
		nMin = nKol;
		nom = i;
	}
	if (nom<0) ::MyError(17);
	ExtractMake(nom,0.05);
}

ostream& operator<< (ostream& os, MyTask& task) {
	int nBestBoundSimple = 999999;
	int i;
	for (int i=0; i<min(15,task.GetSize()); i++) {
		MySubTask* pST = (MySubTask*)task.GetAt(i);
		nBestBoundSimple = min(nBestBoundSimple,pST->BoundSimple());
	}
	os	<< "planes: " << task.arrPlaneMain.GetSize() << "   " 
		<< "little-subtasks: " << task.ltMain.GetSize() << "   " 
		<< "big-subtasks: " << task.GetSize() << endl << "    " 
		<< "best simple bound: " << nBestBoundSimple << "   " 
		<< "opt.: " << task.nOpt 
		<< endl;
	for (i=0; i<min(15,task.GetSize()); i++) {
		MySubTask* pST = (MySubTask*)task.GetAt(i);
		if (i==0) os <= *pST;
		else      os << *pST;
		//os << *pST;
		os << " ";
	}
	os << " ..." << endl << endl << endl;
	return os;
}

/*   
int MyTask::Step () {
	MySubTask* stCurrent = Extract(0);
	if (stCurrent==NULL) return 4;	//   
	MySubTask* stR = stCurrent->MakeRight();
	MyAdd(stCurrent);				//      
	//         ,     -
	//        
	//  -:   ,       
	//     
	if (stR==NULL) return -1;	
		//   - ,     ;
		//   :   ,    
		//    !
	return ProofReady(stR);
}

void MyTask::SubStep () {
	MySubTask* stFirst = Extract(0);
	if (stFirst==NULL) return;
	int m = stFirst->GetRandomSquare();
	if (m<0) ::MyError(9);
	int nom = arrPlaneMain.PlaneByPoint(m);
	if (nom<0) {
		//     ( )     
		ltMain.MyAdd(new MyLittleSubTask(&QubeMain,m));
		//     -       
		// (    );       
		MyPlane* planeNew = QubeMain.MakePlaneRnd(m);  
		if (planeNew==NULL) MyError(10);
		arrPlaneMain.Add(planeNew);
		nom = arrPlaneMain.ExistsPlane(planeNew);
		if (nom!=arrPlaneMain.GetUpperBound()) MyError(11);
	}
	MySubTask* stR = stFirst->MakeRight(nom);
	MyAdd(stFirst);
	ProofReady(stR);
}
		
int MyTask::ExtractMake (int nom) {
	MySubTask* stCurrent = Extract(nom);
	if (stCurrent==NULL) return 4;	//   
	MySubTask* stR = stCurrent->MakeRight();
	MyAdd(stCurrent);				//      
	//         ,     -
	//        
	//  -:   ,       
	//     
	if (stR==NULL) return -1;	
		//   - ,     ;
		//   :   ,    
		//    !
	return ProofReady(stR);
}

int MyTask::ProofReady (MySubTask* stR) {
	if (!stR->Ready()) {
		MyAdd(stR);
		return 0;
	}
	int n = stR->BoundYes();
	int nRet = 1;
	if (n<nOpt) { 
		nOpt = n; 
		//arrYesOpt = stR->GetYes(); 
		nRet = 2; 
	}
	delete stR;
	return nRet;
}

void MyTask::BigStep () {
	ltMain.Step();
	if (GetSize()<=0) return;
	bool bMakeNewPlane = false;	//       
	if (GetSize()>=100 && ::RndLT(0.1)) {	//       
		int kolSim = 999999, kolYes = 999999, kolYNo = 999999, 
			nomSim = -1, nomYes = -1, nomYNo = -1;
		for (int i=1; i<GetSize(); i++) {	// sic!
			MySubTask* stCurrent = (MySubTask*)GetAt(i);
			int kol = stCurrent->BoundSimple();
			if (kol<kolSim) { kolSim = kol; nomSim = i; continue; }
			kol = stCurrent->BoundYes();
			if (kol<kolYes) { kolYes = kol; nomYes = i; continue; }
			kol = stCurrent->BoundYesNo();
			if (kol<kolYNo) { kolYNo = kol; nomYNo = i; }
		}
		if (nomSim>nomYes) ::Obmen(nomSim,nomYes);
		if (nomYes>nomYNo) ::Obmen(nomYes,nomYNo);
		if (nomSim>nomYes) ::Obmen(nomSim,nomYes);	// once more!
		if (nomYNo>0) this->ExtractMake(nomYNo);	// sic!
		if (nomYes>0) this->ExtractMake(nomYes);	// sic!
		if (nomSim>0) this->ExtractMake(nomSim);	// sic!
	}
	bMakeNewPlane = (this->ExtractMake(0) >= 3);
	if (bMakeNewPlane || ::RndLT(0.05)) SubStep();
}
*/

/*    -   
void MyArraySubTask::MyAdd (MySubTask* pAdd) {
	InsertAt(0,pSTAdd);
	int nBoundSTAdd = pSTAdd->BoundSecond();
	for (int i=0; ; i++) {
		if (i+1 > GetUpperBound()) return;
		MySubTask* pTmp = (MySubTask*)GetAt(i+1);
		if (nBoundSTAdd <= pTmp->BoundSecond()) return;
		SetAt(i,pTmp);
		SetAt(i+1,pSTAdd);
	}
}
*/
