
#if !defined(_Big)
#define _Big

#include <fstream>
using namespace std; 
#include <iostream>
using namespace std; 
#include <iomanip>
using namespace std; 

#include "Qube.h"
#include "Little.h"


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyWordArray -    -  

class MyWordArray : public CWordArray {
public:
	MyWordArray () : CWordArray() {}
	MyWordArray (MyWordArray& copy);
	virtual ~MyWordArray () {}
	void MyAdd (int nom);
	bool ExistsNom (int nom);
	//operator= (MyWordArray& copy);
	void DeleteNom (int nom);
	friend ostream& operator<< (ostream& os, MyWordArray& wordarray);
private:
	void MyAddRec (int nom, int nL, int nR);
	bool ExistsNomRec (int nom, int nL, int nR);
	void AddCopy (MyWordArray& copy);
	int Monolit (int nStart);	// . 
};

//bool operator>= (MyWordArray& wa1, MyWordArray& wa2);
bool operator== (MyWordArray& wa1, MyWordArray& wa2);


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MySubTask (Big) - 

class MySubTask {
private:
	MyQube* pQube;				// kein Destructor!
	MyArrayPlane* pArrayPlane;	// kein Destructor!
	MyWordArray arrYes, arrNo;	
		//  , ,   ,   Little! 
		//    ,     *pArrayPlane
	//MyQube QubeThis;	//       1
	MyQube* pQubeThis;
	int nHowTimes;		//      ;
						//   ,    AddYes()  AddNo();
						//   1  ;   BoundSecond()
	int nBound;			//    BoundSecond();
						// !       -1 -
						//  ,      !
public:
	MySubTask (MyQube* pQube, MyArrayPlane* pArrayPlane);
		//  -    
	MySubTask (MySubTask& copy);
	void InitStart ();	//  ,    
						//    
	virtual ~MySubTask () { delete pQubeThis; }
	int SelectPlaneSimple ();
		//       :
		// ,    1    QubeThis
		//    *pArrayPlane  ,      1
		// ( -      arrYes   arrNo),
		//   -1
	bool Ready ()  { return BoundSimple()<=0; }
	int BoundSimple ();	//     -     1
	int BoundYes ()  { return arrYes.GetSize(); }
	int BoundYesNo ()  { return arrYes.GetSize() + arrNo.GetSize(); }
	//bool Tabu (int nom)  { return arrNo.ExistsNom(nom); }
private:
	void AddYes (int nom);
	void AddNo  (int nom);
public:
	//MyWordArray& GetYes () { return arrYes; }
	//MyWordArray& GetNo () { return arrNo; }
	int GetBound ();
	//MySubTask* MakeRight ();
	MySubTask* MakeRight (int nom);
		//   ,    ;
		//  NULL -    ,
		// ..        ;
		//    ""  
	int GetRandomSquare ();
		//    -    *pQube     QubeThis;
		//  -1 -   
	void IntHowTimes ();
	bool operator== (MySubTask& other);
	friend ostream& operator<= (ostream& os, MySubTask& subtask);
	friend ostream& operator<< (ostream& os, MySubTask& subtask);
};



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyArraySubTask (Big) - 

class MyArraySubTask : public CPtrArray {	// of MySubTask*
public:
	MyArraySubTask () : CPtrArray() {}
	virtual ~MyArraySubTask ();
	MySubTask* MyGet (int n) { return (MySubTask*)GetAt(n); }
	void MyAdd (MySubTask* pAdd); 
		//      BoundSecond() ("");
		//   ,     
	//MySubTask* ExtractFirst ();
		//  ;  NULL,   
	MySubTask* Extract (int nom);
	void Clean (int nOpt);
};


///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyTask (Big) - 

class MyTask : public MyArraySubTask {
private:
	MyQube QubeMain;
	MyArrayPlane arrPlaneMain;
	MyLittleTask ltMain;
	//  -   
	MyWordArray arrYesOpt;
	int nOpt;	//      
public:
	MyTask (MyQube& qube);
	virtual ~MyTask () {}
/*  
private:
	int Step ();
		//    ,     ;
		//    ;
		// :-1 - ""  
		//			0 - ,   ; ,  ,     
		//			1 -    ,      
		//			2 -  ,    ;
		//			4 -    ;
	void SubStep ();
		//       
		//             
		// :	0 - ,   ; ,  ,     
		//			1 -    ,      
		//			2 -  ,    ;
		//			3 -      ( , ..  )
	int ProofReady (MySubTask* stR);
		//  0,1,2 -  Step()
		//      (  ),   ,
		//     -       
*/
private:
	void ExtractMake (int nom, double rProbaMakePlane);
		// nom -     ,
		// rProMakeplane -      
public:
	void BigStep ();
	friend ostream& operator<< (ostream& os, MyTask& task);
};


#endif
