
#include "StdAfx.h"
#include "Little.h"
#include "Utily.h"
#include "Random.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;

#endif

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MySuperSet - 

const int dim = 32;

class MySuperSet {
private:
	int Array[dim];
public:
	MySuperSet ();
	void MyAdd (int n);
	int GetMax ();
};

MySuperSet::MySuperSet () {
	for (int i=0; i<dim; i++) Array[i] = 0;
}

void MySuperSet::MyAdd (int n) {
	Array[n]++;
}
	
int MySuperSet::GetMax () {
	int max = 0;	// sic!
	int ret = -1;	// sic!
	for (int i=0; i<dim; i++) {
		if (Array[i]<=max) continue;
		max = Array[i];
		ret = i;
	}
	return ret;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyLittleSubTask - 
			
MyLittleSubTask::MyLittleSubTask (MyQube* pQube)
	//  Plane     -     
	// (,  InitPoint())
	//   Plane     
{
	Init(pQube);
	InitPoint(pQube->RandomPoint());
}
			
MyLittleSubTask::MyLittleSubTask (MyQube* pQube, int mPoint)
	//  -    
{
	Init(pQube);
	InitPoint(mPoint);
}
	
MyLittleSubTask::MyLittleSubTask (MyLittleSubTask& copy) :
	Plane(copy.Plane)
{
	pQube = copy.pQube;
	nDim = copy.nDim;
	InitMemory();
	for (int i=0; i<nDim; i++) {
		No[i] = copy.No[i];
	}
	nScore = copy.nScore;
}

MyLittleSubTask::~MyLittleSubTask () {
	delete[] No;
}
	
void MyLittleSubTask::Init (MyQube* pQube) {
	this->pQube = pQube;
	nDim = pQube->GetDim();
	InitMemory();
	for (int i=0; i<nDim; i++) No[i] = false;	// ..    
	nScore = 0;	//   ;
				//     ,   ! "  23..."
}
	
void MyLittleSubTask::InitMemory () {
	No = new bool[nDim];
}
	
void MyLittleSubTask::InitPoint (int mPoint) {
	if (mPoint<0) ::MyError(6);
	Plane.Init(nDim,mPoint);
}	

/*
void MyLittleSubTask::MakeCostStart () {
	for (int i=0; i<nDim; i++) Cost[i] = 0;
	for (int m=0; m<pQube->GetMDim(); m++) {	//   
		if (!pQube->Get(m)) continue;
		for (i=0; i<nDim; i++) {				//      
			int mmm = ::Sosed(m,nDim,i);
			if (pQube->Get(mmm)) Cost[i]++;
		}
	}
	for (i=0; i<nDim; i++) {
		if (Cost[i]%2==1) ::MyError(7);
		Cost[i] /= 2;
	}
}
*/

int MyLittleSubTask::ExtandRandom () {
	int nAdd = ::Rnd(nDim);
	for (int i=0; i<nDim; i++) {
		int nCoord = (i+nAdd) % nDim;	//    
		if (No[nCoord] || Plane[nCoord]==2) continue;
		//  !   MyPlane    []
		//       
		Plane.InitSearch();
		for (;;) {
			int m = Plane.MakeNext();
			if (m<0) return nCoord;			//        
			int mmm = ::Sosed(m,nDim,nCoord);
			if (!pQube->Get(mmm)) break;	//     -   
		}
	}
	return -1;
}

/*
int MyLittleSubTask::ExtandBest () {
	int nCostBest = -1;
	int nCoordBest = -1;
	for (int nCoord=0; nCoord<nDim; nCoord++) {	//    
		if (No[nCoord] || Plane[nCoord]==2) continue;
		//       
		Plane.InitSearch();
		for (;;) {
			int m = Plane.MakeNext();
			if (m<0) {						//        
				//int nCost = Cost[nCoord];
				int nCost = pQube->GetCost(nCoord);
				if ( (nCost>nCostBest) || (nCost==nCostBest && ::RndBool()) ) {
					nCostBest = nCost;
					nCoordBest = nCoord;
				}
				break;						//     -   
			}
			int mmm = ::Sosed(m,nDim,nCoord);
			if (!pQube->Get(mmm)) break;	//     -   
		}
	}
	return nCoordBest;
}
*/

int MyLittleSubTask::ExtandGreedy () {
	if (::RndLT(0.1)) {
		int n = ExtandGreedy3();
		if (n>=0) return n;
	}
	int n = ExtandGreedy2();
	if (n>=0) return n;
	return ExtandRandom();
}
	
int MyLittleSubTask::ExtandGreedy2 () {
	MySuperSet pairs;
	for (int n1=0; n1<nDim-1; n1++)  {
		if (No[n1] || Plane.Get(n1)==2) continue;
		//          n1
		for (int n2=n1+1; n2<nDim; n2++)  {
			if (No[n2] || Plane.Get(n2)==2) continue;
			//   ,       , n1  n2
			//       (,  1)  Ш 
			Plane.InitSearch();
			for (;;) {
				int m = Plane.MakeNext();
				if (m<0) {						//        
					pairs.MyAdd(n1);
					pairs.MyAdd(n2);
					break;						//     
				}
				int m1 = ::Sosed(m,nDim,n1);
				if (!pQube->Get(m1)) break;		//     
				int m2 = ::Sosed(m,nDim,n2);
				if (!pQube->Get(m2)) break;		//     
				int mmm = ::Sosed(m1,nDim,n2);
				if (mmm!=::Sosed(m2,nDim,n1)) ::MyError(21);
				if (!pQube->Get(mmm)) break;	//     
			}
		}
	}
	return pairs.GetMax();
}
	
int MyLittleSubTask::ExtandGreedy3 () {	//  
	MySuperSet threes;
	for (int n1=0; n1<nDim-2; n1++)  {
		if (No[n1] || Plane.Get(n1)==2) continue;
		for (int n2=n1+1; n2<nDim-1; n2++)  {
			if (No[n2] || Plane.Get(n2)==2) continue;
			for (int n3=n2+1; n3<nDim; n3++)  {
				if (No[n3] || Plane.Get(n3)==2) continue;
				Plane.InitSearch();
				for (;;) {
					int m = Plane.MakeNext();
					if (m<0) {
						threes.MyAdd(n1);
						threes.MyAdd(n2);
						threes.MyAdd(n3);
						break;
					}
					int m1 =	::Sosed(m,nDim,n1);		if (!pQube->Get(m1)) break;
					int m2 =	::Sosed(m,nDim,n2);		if (!pQube->Get(m2)) break;
					int m3 =	::Sosed(m,nDim,n3);		if (!pQube->Get(m3)) break;
					int m12 =	::Sosed(m1,nDim,n2);	if (!pQube->Get(m12)) break;
					int m13 =	::Sosed(m1,nDim,n3);	if (!pQube->Get(m13)) break;
					int m23 =	::Sosed(m2,nDim,n3);	if (!pQube->Get(m23)) break;
					int m123 =	::Sosed(m12,nDim,n3);	if (!pQube->Get(m123)) break;
				}
			}
		}
	}
	return threes.GetMax();
}

MyLittleSubTask* MyLittleSubTask::MakeRight () {
	int nCoord = ExtandGreedy();	// .      -     
	if (nCoord<0) return NULL;
	MyLittleSubTask* stRight = new MyLittleSubTask(*this); //  
	stRight->AddYes(nCoord);
	this->AddNo(nCoord);
	return stRight;
}
	
ostream& operator<< (ostream& os, MyLittleSubTask& mlst) {
	cout << "score :" << mlst.nScore << endl;
	cout << "yes (plane):" << mlst.Plane << endl;
	cout << "no:           ";
	int nDim = mlst.nDim;  if (nDim>=10) cout << " ";
	for (int i=0; i<nDim; i++) cout << (mlst.No[i] ? 1 : 0);
	cout << endl;
	return os;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyArrayLittleSubTask - 

MyArrayLittleSubTask::~MyArrayLittleSubTask () {
	for (int i=0; i<GetSize(); i++) {
		MyLittleSubTask* pSubTask = (MyLittleSubTask*)GetAt(i);
		delete pSubTask;
	}
}
	
void MyArrayLittleSubTask::MyAdd (MyLittleSubTask* pSTAdd) {
	InsertAt(0,pSTAdd);
	for (int i=0; ; i++) {
		if (i+1 > GetUpperBound()) return;
		MyLittleSubTask* pTmp = (MyLittleSubTask*)GetAt(i+1);
		if (pTmp->GetScore() <= pSTAdd->GetScore()) return;
		SetAt(i,pTmp);
		SetAt(i+1,pSTAdd);
	}
}

MyLittleSubTask* MyArrayLittleSubTask::ExtractFirst () {
	if (GetSize()<=0) return NULL;
	MyLittleSubTask* pSTReturn = (MyLittleSubTask*)GetAt(0);
	this->RemoveAt(0);
	return pSTReturn;
}

/*
bool operator< (MyLittleSubTask& lst1, MyLittleSubTask& lst2) {
	return lst1.GetScore() < lst2.GetScore();
}
*/
	
ostream& operator<< (ostream& os, MyArrayLittleSubTask& arrsubtask) {
	int nSize = arrsubtask.GetSize();
	cout << "* number of subtasks: " << nSize;
	if (nSize>10) { 
		cout << " (we print first 10 ones)";
		nSize = 10;
	}
	cout << endl;
    for (int i=0; i<nSize; i++) {
        MyLittleSubTask* pSubTask = (MyLittleSubTask*)arrsubtask.GetAt(i);
        os << "*subtask # " << i << "     " << *pSubTask;
    }
	return os;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MyLittleTask - 

/*   
MyLittleTask::MyLittleTask (MyQube* pQube, MyArrayPlane* pArrPlane)
{
	this->nDim = pQube->GetDim();
	this->pQube = pQube;
	this->pArrPlane = pArrPlane;
	Add(new MyLittleSubTask(pQube));	// MyAdd()  
	//      -    "  ",
	// ..     ;
	//      "" 
	pArrPlane16 = new MyArrayPlane16(pQube->GetMDim());
}
*/

MyLittleTask::MyLittleTask (MyQube* pQube, MyArrayPlane* pArrPlane, int kolSubTasks) {
	int m;
	this->nDim = pQube->GetDim();
	this->pQube = pQube;
	this->pArrPlane = pArrPlane;
	//     *pQube     :
	RndInt ri;
	for (int m=0; m<pQube->GetMDim(); m++)  if (pQube->Get(m))  ri.Add(m);
	//      (.. )   :
	for (m=0; m<kolSubTasks; m++) {
		int mPoint = ri.GetAnswer();
		if (mPoint<0) break;
		Add(new MyLittleSubTask(pQube,mPoint));
	}
	pArrPlane16 = new MyArrayPlane16(pQube->GetMDim());
}

int MyLittleTask::Step () {
	MyLittleSubTask* stCurrent = ExtractFirst();
	if (stCurrent==NULL) return 4;
	MyLittleSubTask* stR = stCurrent->MakeRight();
	if (stR==NULL) {	//    -       arrPlane
		MyPlane* planeNew = new MyPlane(stCurrent->GetPlane());
		// !  stCurrent->GetPlane()     stCurrent - 
		// ,    .

		if (GetSize()<1) {
		cout << *planeNew << endl;
		}
		delete stCurrent;
		if (pQube->CanExtand(*planeNew)) {
			delete planeNew;
			return 3;
		}
		if (pArrPlane->ExistsPlane(planeNew)>=-1) {	// sic!!!
			delete planeNew;
			return 1;
		}
		//     
		if (this->nDim<=16) pArrPlane16->AddPlane(planeNew);
		pArrPlane->Add(planeNew);
		return 0;
	}
	MyAdd(stCurrent);
	MyAdd(stR);
	return 2;
}

ostream& operator<< (ostream& os, MyLittleTask& littletask) {
	cout << endl << "*** begin printing new little task";
	cout << endl << "** begin printing qube" << endl << *littletask.pQube << endl;
	cout << "** begin printing array of planes" << endl << *littletask.pArrPlane;
	MyArrayLittleSubTask& alst = littletask;  
	cout << "** begin printing array of little SUBtask" << endl << alst;
	cout << "*** end printing new little task" << endl;
	return os;
}

void MyLittleTask::Run16 () {
	for (;;) {
		int n = Step();
	
		//	cout << n << " " << GetSize() << " " << pArrPlane->GetSize() << endl;	
		if (n==4){
			cout<< pArrPlane->GetSize() << endl;	
	//	cout << pArrPlane << endl;
		break;}
	}
}




/*
MyLittleSubTask::MyLittleSubTask (MyMatrix* pMatrix, int x, int y) :
	yesX(pMatrix->GetDimX()),	noX(pMatrix->GetDimX()),
	yesY(pMatrix->GetDimY()),	noY(pMatrix->GetDimY())
{
	this->pMatrix = pMatrix;
	yesX.SetNewTrue(x);
	yesY.SetNewTrue(y);
	nScore = 2;	// sic!
}

MyLittleSubTask::MyLittleSubTask (MyMatrix* pMatrix, int x, int y, int nScore) :
	yesX(pMatrix->GetDimX()),	noX(pMatrix->GetDimX()),
	yesY(pMatrix->GetDimY()),	noY(pMatrix->GetDimY())
{
	this->pMatrix = pMatrix;
	yesX.SetNewTrue(x);
	yesY.SetNewTrue(y);
	this->nScore = nScore;	//     
}
	
MyLittleSubTask::MyLittleSubTask (MyLittleSubTask& copy) :
	yesX(copy.yesX),	noX(copy.noX),	
	yesY(copy.yesY),	noY(copy.noY)
{
	this->pMatrix = copy.pMatrix;
	this->nScore = copy.nScore;
}

bool MyLittleSubTask::InitRandom (int& x, int& y) {
	//  MySubTask::GetRandomSquare
	RndPairs pairs;
	for (int i=0; i<pMatrix->GetDimX(); i++)  for (int j=0; j<pMatrix->GetDimY(); j++) {
		if (!pMatrix->Get(i,j)) continue;			//    (   ) 
		if (yesX.Get(i) && yesY.Get(j)) continue;	//   
		if (noX.Get(i) || noY.Get(j)) continue;		//   
		pairs.AddPair(i,j);
	}
	if (!pairs.GetAnswer(x,y)) return false;
	yesX.SetNewTrue(x); yesY.SetNewTrue(y); 
	return true;
}

int MyLittleSubTask::CostX (int newX) {
	int nScore = 0;
	for (int j=0; j<pMatrix->GetDimY(); j++) {
		if (noY.Get(j)) continue;
		if (yesY.Get(j)) {
			if (!pMatrix->Get(newX,j)) return -1;
			nScore += 2 * pMatrix->GetCostY(j);
		}
		else nScore += pMatrix->GetCostY(j);
	}
	return nScore;
}

int MyLittleSubTask::CostY (int newY) {
	int nScore = 0;
	for (int i=0; i<pMatrix->GetDimX(); i++) {
		if (noX.Get(i)) continue;
		if (yesX.Get(i)) {
			if (!pMatrix->Get(i,newY)) return -1;
			nScore += 2 * pMatrix->GetCostX(i);
		}
		else nScore += pMatrix->GetCostX(i);
	}
	return nScore;
}


bool MyLittleSubTask::ExtandX (int& newX, int& nScore) {
	nScore = -1;
	for (int i=0; i<pMatrix->GetDimX(); i++) {
		if (yesX.Get(i) || noX.Get(i)) continue;
		int n = CostX(i);
		if (n<=nScore) continue;
		nScore = n;
		newX = i;
	}
	return nScore>=0;
}

bool MyLittleSubTask::ExtandY (int& newY, int& nScore) {
	nScore = -1;
	for (int j=0; j<pMatrix->GetDimY(); j++) {
		if (yesY.Get(j) || noY.Get(j)) continue;
		int n = CostY(j);
		if (n<=nScore) continue;
		nScore = n;
		newY = j;
	}
	return nScore>=0;
}

bool MyLittleSubTask::CanExtandX () {
	for (int i=0; i<pMatrix->GetDimX(); i++) {
		if (yesX.Get(i)) continue;				//     
		for (int j=0; j<pMatrix->GetDimY(); j++)  {
			if (!yesY.Get(j)) continue;			//    -   
			if (!pMatrix->Get(i,j)) goto L;		// 0     1 -    
		}
		return true;							//    
		L:;
	}
	return false;
}

bool MyLittleSubTask::CanExtandY () {
	for (int j=0; j<pMatrix->GetDimY(); j++) {
		if (yesY.Get(j)) continue;
		for (int i=0; i<pMatrix->GetDimX(); i++)  {
			if (!yesX.Get(i)) continue;
			if (!pMatrix->Get(i,j)) goto L;
		}
		return true;
		L:;
	}
	return false;
}

void MyLittleSubTask::MakeScore () {
	int yX = yesX.GetDimGrid(), yY = yesY.GetDimGrid(), nX = noX.GetDimGrid(), nY = noY.GetDimGrid();
	nScore = 2 * yX * yY - (nX*nY + nX + nY);
}
	
void MyLittleSubTask::AddYesX (int newX) { 
	yesX.SetNewTrue(newX); 
	if (nScore<999999) MakeScore();	// a      -
}
	
void MyLittleSubTask::AddYesY (int newY) { 
	yesY.SetNewTrue(newY); 
	if (nScore<999999) MakeScore();	// 
}
	
void MyLittleSubTask::AddNoX (int newX) { 
	noX.SetNewTrue(newX); 
	MakeScore();
}
	
void MyLittleSubTask::AddNoY (int newY) { 
	noY.SetNewTrue(newY); 
	MakeScore();
}
		
MyGrid* MyLittleSubTask::MakeGrid () {
	//      ;
	//    - .    ~readme.rtf
	if (CanExtandX() || CanExtandY()) return NULL;
	return new MyGrid(yesX,yesY);
}

        
MyLittleSubTask* MyArrayLittleSubTask::GetFirst () {
	if (GetSize()<=0) return NULL;
	return (MyLittleSubTask*)GetAt(0);
}


		
void MyLittleTask::SpecialAddSubTask (int x, int y) {
	MyLittleSubTask* pLST = new MyLittleSubTask(pMatrix,x,y,999999);	// sic!
	this->InsertAt(0,pLST);
}
*/
