
#include "StdAfx.h"
#include "Random.h"
#include "Utily.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

const int nnn1 = 19217, nnn2 = 45213, nnn3 = 65293;	//   

int nRnd;

int MyRandom () {
	nRnd *= nnn1;
	nRnd += nnn2;
	nRnd %= nnn3;
	return nRnd;
}

int Rnd (int nMax) {
	return MyRandom() % nMax;
}

double RndReal () { 
	return (MyRandom()+1.0) / double(nnn3); 
}

bool RndLT (double r) { 
	return RndReal() < r; 
}

bool RndBool () { 
	return RndLT(0.5); 
}

const double rOtnKol = 0.1;	
	//  :
	//     ,      ;
	//       -       

int SimpleDimPlane (int nDim) {
	int nRet = int(rOtnKol*nDim);
	BoundsInt(nRet,1,nDim);
	return nRet;
}

int MyRndDimPlane (int nDim) {
	const int maxSteps = 100;			//      (. .  SimpleDimGrid)
	double rStep = 1.0 / double(nDim);	//   
	double rProba = rStep;				//   (   )
	int nSimpleDim = SimpleDimPlane(nDim);
	int nDimRet = 1;
	for (int nStep=0; nStep<maxSteps; nStep++) {
		if (RndLT(rProba)) return nDimRet;
		if (nDimRet<nSimpleDim) rProba += rStep; else rProba *= (1.0-2.0*rOtnKol);
		Bounds(rProba,0.01,0.5);
		if (++nDimRet<=nDim) continue;
		nDimRet = 1;
		rProba = rStep;
	}
	return nSimpleDim;
}
	
int RndInt::GetAnswer () {
	int nSize = GetSize();
	if (nSize<=0) return -1;
	int nom = (nSize==1) ? 0 : Rnd(nSize);
	int ret = GetAt(nom);
	RemoveAt(nom);
	return ret;
}

bool RndPairs::GetAnswer (int& x, int& y) {
	int nSize = XXX.GetSize();
	if (nSize<=0 || nSize!= YYY.GetSize()) return false;
	int nom = nSize==1 ? 0 : Rnd(nSize);
	x = XXX[nom];  XXX.RemoveAt(nom);
	y = YYY[nom];  YYY.RemoveAt(nom);
	return true;
}
